<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	protected $obj_mutasi;
	protected $obj_date;
	// variable definition
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		// pdf	
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$this->obj_mutasi = $this->obj_ctrl->LoadBusiness('mutasi', 'mysql', $this->arr_config['db']);
		$loaded_query = array('evaluasi', 'kegiatan', 'str');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		
		// -- 
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');
		// load plugins
		$this->obj_ctrl->LoadFile('tcpdf/tcpdf.php', 'plugins');
		$this->obj_tcpdf = $this->obj_ctrl->LoadClass('TCPDF');
	}
	
	public function PageView(){
		// display pdf download
		self::DownloadSuratRekomendasi();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
		
	// operation
	private function DownloadSuratRekomendasi(){
		$person = $this->obj_mutasi->GetDataAsSingleArray("GetSuratMutasiAnggotaByIdPerson", array($this->arr_routes['params'][1]));
		$path = "doc/temp/blank.jpg";
		if(!empty($person)){
			// display foto
			$path = "doc/person/".$person['id_person']."/foto/".$person['photo'];
			if(!is_file($path))
				$path = "doc/temp/blank.jpg";
		}
		// parse data
		//$rekomendasi = $this->obj_cpd->GetDataAsSingleArray("GetSuratRekomendasiByStr", array($this->arr_routes['params'][0], $this->arr_routes['params'][1]));
		// parse data skp
		$skp_total = 0;
		$formulas = 250 / 150;
		$rs_id = $this->obj_cpd->GetResourceId("GetListPeriodeKegiatanById", array($this->arr_routes['params'][1], $this->arr_routes['params'][0]));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				// get nilai per tahun
				// get nilai by params 
				$nilai = self::GetNilaiByTanggal($this->arr_routes['params'][0], $rec['tgl_mulai'], $rec['tgl_selesai']);
				$skp_total = $skp_total + $nilai;
			}
		}
				$skp_ikafmi_total = number_format($skp_total, 0, ',', '');
				//$this->obj_tmpl->addVar('display', 'TOTAL_PERTAHUN_ALL', $skp_ikafmi_total);
				$skp_konversi_total = $skp_total * $formulas;
				$skp_konversi_total = number_format($skp_konversi_total, 0, ',', '');
				//$this->obj_tmpl->addVar('display', 'TOTAL_PERTAHUN_KONVERSI', $skp_konversi_total);	
		// print pdf
		$this->obj_tcpdf->setPrintHeader(false);
		$this->obj_tcpdf->setPrintFooter(false);
		$this->obj_tcpdf->SetDisplayMode('real');
		$this->obj_tcpdf->SetMargins(10, 8);		
		// add a page
		$this->obj_tcpdf->AddPage();	
		$this->obj_tcpdf->SetFont("arial", "BI", 10);	
		// create some HTML content
		$tablealign = '
<table border="none" width="100%" cellpadding="2">
  <tr>
    <td width="70" align="left"><img src="doc/temp/logo-ppni.jpg" width="75" height="75" /></td>
    <td align="center" width="400"><b><br />
     PERSATUAN PERAWAT NASIONAL INDONESIA</b><br />
      <br />
      <font size="9">Wisma DPP PPNI:<br />
	  Jl. Lenteng Agung Raya No 64 RT 006/RW 008 Kec. JagakarsaJakarta Selatan 12610; <br />www.inna-ppni.or.id; dppppni@gmail.com;Telp: +6221 2271 0272 <br />Badan Hukum: AHU-93.AH.01.07</font></td>
    <td width="70" align="right"></td>
  </tr>
</table>
<br />
<img src="doc/temp/hr.jpg" width="530" />
<br />
<br />

<table width="750" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="100">No</td>
    <td width="5">:</td>
    <td width="645">001 / VI / PPNI / 2014</td>
  </tr>
  <tr>
    <td width="100">Lampiran</td>
    <td width="5">:</td>
    <td width="645">1 (satu) lbr</td>
  </tr>
  <tr>
    <td width="100">Hal</td>
    <td width="5">:</td>
    <td width="645">Permohonan MUTASI Anggota PPNI</td>
  </tr>
</table>
<table border="none" width="100%">
   <tr>
    <td colspan="3"></td>
  </tr> <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3">Kepada Yth;</td>
  </tr>
  
  <tr>
    <td colspan="3">Ketua DPD '.$person['kota_mutasi'].'</td>
  </tr>
  <tr>
    <td colspan="3">Di '.$person['wilayah_mutasi'].'</td>
  </tr>
  
  <tr>
    <td colspan="3"></td>
  </tr>
  
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3">Bersama ini kami sampaikan bahwa :  </td>
  </tr>
  <tr>
    <td colspan="2"></td>
  </tr>
  <tr>
    <td width="170">Nama</td>
    <td width="15">:</td>
    <td width="300">'.$person['prefix'].' '.$person['nama_lengkap'].' '.$person['suffix'].'</td>
  </tr>
  <tr>
    <td colspan="2"></td>
  </tr>
  <tr>
    <td width="170">Tempat Tanggal Lahir</td>
    <td width="15">:</td>
    <td width="300">'.$person['tempat_lahir'].','.$this->obj_date->GetFullDate($person['tanggal_lahir'], 'ins').'</td>
  </tr>
  <tr>
    <td colspan="2"></td>
  </tr>
 
  <tr>
    <td width="170">NIRA </td>
    <td width="15">:</td>
    <td>'.$person['no_anggota'].'</td>
  </tr>
  <tr>
    <td colspan="2"></td>
  </tr>
 
  <tr>
    <td width="170">Komisariat </td>
    <td width="15">:</td>
    <td>'.$person['cabang'].'</td>
  </tr>
  <tr>
    <td colspan="2"></td>
  </tr>
  <tr>
    <td width="170">Alamat</td>
    <td width="15">:</td>
    <td width="300">'.$person['alamat'].'</td>
  </tr>
  
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td  colspan="3">Mengajukan permohonan MUTASI Anggota ke  <b>'.$person['wilayah_mutasi'].'</b> dan dari pihak kami TIDAK KEBERATAN ATAU SETUJU untuk permohonan mutasi anggota bagi kepada yang tersebut diatas.</td>
  </tr>
 <tr>
    <td colspan="3"></td>
  </tr>
 
  <tr>
    <td colspan="3">Demikian Rekomendasi kami ini dibuat untuk dapat dipergunakan sebagaimana mestinya. <br/>Atas perhatian dan kerjasamanya disampaikan terima kasih</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3"><div align="right">'.$person['wilayah'].','.$this->obj_date->GetFullDate(date("y-m-d")).'</div></td>
  </tr>
   <tr>
    <td width="250" align="center">Mengetahui dan Menyetujui<br/>
Pengurus PPNI '.$person['wilayah'].'<br/>
Ketua
</td>
    <td width="6"></td>
    <td width="346" align="center">Pemohon</td>
  </tr>
    <tr>
    <td width="250" align="center"><img src="doc/temp/signature/ttd.jpg" /></td>
    <td width="6"></td>
    <td width="346" align="center"><img src="doc/temp/signature/ttd.jpg" /></td>
  </tr>
   <tr>
    <td width="250" align="center"></td>
    <td width="6"></td>
    <td width="346" align="center">'.$person['prefix'].' '.$person['nama_lengkap'].' '.$person['suffix'].'</td>
  </tr>
   <tr>
    <td width="159" align="center">NIRA</td>
    <td width="6"></td>
    <td width="426" align="center">NIRA</td>
  </tr>
  <tr>
    <td  width="600"> *) Aspek yang tidak diperlukan, akan secara otomasi di delete oleh sistem</td>
    
  </tr>
 
</table>

';
		// output the HTML content
		$this->obj_tcpdf->writeHTML($tablealign, true, 0, true, 0);
		//Close and output PDF document
		//$this->obj_tcpdf->Output("Surat-Rekomendasi-PKB.pdf", "D");
                $this->obj_tcpdf->Output("Surat-Rekomendasi-PKB.pdf", "I"); 
	}
	
	//get nilai skp
	private function GetNilaiByTanggal($id_person, $str_tgl_mulai, $str_tgl_selesai){
		$total = 0;
		// parameter
		$params = array($id_person, $str_tgl_mulai, $str_tgl_selesai);
		// get data
		$rs_id = $this->obj_cpd->GetResourceId("GetEvaluatedP2KBGroupByForm", $params);
		// parse data
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				// set ranah
				if(!isset($this->arr_ranah_all[$rec['ranah']])){$this->arr_ranah_all[$rec['ranah']] = '';}
				// get nilai skp
				if($rec['tipe'] == 'rutin')
					$nilai = self::GetNilaiSkpRutin($id_person, $rec['id_form'], $str_tgl_mulai, $str_tgl_selesai);
				else
					$nilai = $rec['nilai'];
				// tabel by ranah
				$this->arr_ranah_all[$rec['ranah']] = $this->arr_ranah_all[$rec['ranah']] + $nilai;		
				$total = $total + $nilai;
			}
		}
		return $total;
	}
	
	private function GetNilaiSkpRutin($id_person, $id_form, $str_tgl_mulai, $str_tgl_selesai){
		$nilai = 0;
		$jumlah = 0;
		// get parameter and indikator
		$arr = $this->obj_cpd->GetDataAsSingleArray("GetParameterAndEngineByForm", array($id_form, $id_form));
		$id_parameter = $arr['parameter'];
		$id_engine = $arr['indikator'];
		// get nilai dalam range tahun kegiatannya
		$rs_id = $this->obj_cpd->GetResourceId("GetDataKegiatanByFormDate", array($id_person, $id_form, $str_tgl_mulai, $str_tgl_selesai));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$arr_field = "";
				$xml = simplexml_load_string($rec["data_kegiatan"]);
				// echo does the casting for you
				$count = count($xml->item);
				for($i=0;$i<$count;$i++){
					$id = intval($xml->item[$i]->idt);
					$value = strval($xml->item[$i]->value);
					if($id == $id_parameter){
						$jumlah = $jumlah + $value;
						break;
					}
				}
			}
		}
		// get list elemen
		$rs_id_list = $this->obj_cpd->GetResourceId("GetElemenListByEngine", array($id_engine));
		if($rs_id_list){
			$group_list = "FIND_IN_SET(0, group_elemen_list)";
			while($rec = mysql_fetch_assoc($rs_id_list)){
				$range_value = explode('-', $rec['list_value'], 2);
				if(sizeof($range_value) >= 2){
					$batas_bawah = round($range_value[0], 2);
					$batas_atas = round($range_value[1], 2);
				}else{
					$batas_bawah = 0;
					$batas_atas = 0;
				}	
				if($jumlah >= $batas_bawah AND $jumlah <= $batas_atas){
					$group_list = "FIND_IN_SET(".$rec['id_list'].", group_elemen_list)";
					break;
				}
			}
		}
		$nilai = $this->obj_cpd->GetDataAsSingleArray("GetNilaiSkpByEngine", array($group_list));	
		if(!empty($nilai))
			return $nilai['nilai_skp'];
		else
			return 0;
	}
	
}

?>